LeetCode-01丨1.两数之和

Posted by jiefang on March 7, 2021

1.两数之和

问题

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
//给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 的那 两个 整数,并返回它们的数组下标。
//
// 你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。
//
// 你可以按任意顺序返回答案。
//
//
//
// 示例 1:
//
//
//输入:nums = [2,7,11,15], target = 9
//输出:[0,1]
//解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
//
//
// 示例 2:
//
//
//输入:nums = [3,2,4], target = 6
//输出:[1,2]
//
//
// 示例 3:
//
//
//输入:nums = [3,3], target = 6
//输出:[0,1]
//
//
//
//
// 提示:
//
//
// 2 <= nums.length <= 103
// -109 <= nums[i] <= 109
// -109 <= target <= 109
// 只会存在一个有效答案
//
// Related Topics 数组 哈希表
// 👍 10145 👎 0

思路

  • 标签:哈希映射
  • 这道题本身如果通过暴力遍历的话也是很容易解决的,时间复杂度在 O(n2)
  • 由于哈希查找的时间复杂度为 O(1),所以可以利用哈希容器 map 降低时间复杂度;
  • 遍历数组 nums,i 为当前下标,每个值都判断map中是否存在 target-nums[i] 的 key 值;
  • 如果存在则找到了两个值,如果不存在则将当前的 (nums[i],i) 存入 map 中,继续遍历直到找到为止;
  • 如果最终都没有结果则抛出异常;
  • 时间复杂度:*;

解答

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
//leetcode submit region begin(Prohibit modification and deletion)
class 两数之和_1 {
    public static void main(String[] args) {
        int[] ints = new int[]{3,2,4};
        int[] result = twoSum(ints,6);
        System.out.println(Arrays.toString(result));
    }
    public static int[] twoSum(int[] nums, int target) {
        Map<Integer,Integer> map = new HashMap<>();
        for(int i=0;i<nums.length;i++){
            if(map.containsKey(target - nums[i])){
                return new int[]{map.get(target - nums[i]),i};
            }
            map.put(nums[i],i);
        }
        return nums;
    }
}
//leetcode submit region end(Prohibit modification and deletion)